//+------------------------------------------------------------------+
//|                                           Chande Momentum        |
//+------------------------------------------------------------------+

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  Red
#property  indicator_width1  2
#property indicator_minimum -80
#property indicator_maximum 80
#property indicator_level1 -50
#property indicator_level2 50
      
extern int CMO_Period = 50;


//---- buffers

double cmo[];
double cmo1[];
double scmo1[];
double cmo2[];
double scmo2[];



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
//---- drawing settings
   SetIndexBuffer(0,cmo);
   SetIndexStyle(0,DRAW_LINE);
   IndicatorShortName("CMO("+CMO_Period+")");

  
   
   ArrayResize(cmo1,Bars);
   ArraySetAsSeries(cmo1,true);
 
   ArrayResize(scmo1,Bars);
   ArraySetAsSeries(scmo1,true);
 
   ArrayResize(cmo2,Bars);
   ArraySetAsSeries(cmo2,true);
 
   ArrayResize(scmo2,Bars);
   ArraySetAsSeries(scmo2,true);  
   
//---- initialization done
   return(0);
  }

int start()
{


   int i, j, k, limit;
   double dif1, cmo3, cmo4, Tcmo1, Tscmo1, Tcmo2, Tscmo2;
   int    counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
  
 //dif1	cmo1	scmo1	cmo2	scmo2	cmo3	cmo4	cmo


 
// If d >= 0, then cmo1i = d and cmo2i = 0 
// If d <   0, then cmo2i = -d and cmo1i = 0 

   for(i = limit; i >= 0; i--)
     {
       dif1 = Close[i]-Close[i+1];
       if(dif1>=0)
         {
           Tcmo1 = dif1;
           Tcmo2 = 0;
         }
       else
         { 
           Tcmo1 = 0;
           Tcmo2 = -dif1;
         }
       cmo1[i] = Tcmo1;
       cmo2[i] = Tcmo2;
     }

 
   for(i = limit; i >= 0; i--)
     {
       Tscmo1 = 0;
       for(j = i + CMO_Period-1; j >= i; j--)Tscmo1 += cmo1[j];
       scmo1[i] = Tscmo1;
     }

 
   for(i = limit; i >= 0; i--)
     {
       Tscmo2 = 0;
       for(j = i + CMO_Period-1; j >= i; j--)Tscmo2 += cmo2[j];
       scmo2[i] = Tscmo2;
     }

//scmo1 - scmo2

      
   for(i = limit; i >= 0; i--)
     {
       cmo3 = scmo1[i]-scmo2[i];
       cmo4 = scmo1[i]+scmo2[i];
       if(cmo4 == 0)cmo4=0.0001;
       cmo[i] = (cmo3/cmo4)*100; 
     }

      
      return(0);
  }
//+------------------------------------------------------------------+



